// Copyright (c) 2015, Google Inc. Please see the AUTHORS file for details.
// All rights reserved. Use of this source code is governed by a BSD-style
// license that can be found in the LICENSE file.

import 'dart:async';

import 'package:build_config/build_config.dart';
import 'package:wrike_ws_generate/jsmimicry_generator.dart';
import 'package:source_gen/source_gen.dart';
import 'package:build_runner_core/build_runner_core.dart';
import 'package:build_runner/build_runner.dart';

// ignore_for_file: comment_references

/// Example of how to use source_gen with [BuiltJsonGenerator].
///
/// [BuiltJsonGenerator] is usually used with [BuiltValueGenerator] and
/// [EnumClassGenerator] because types generated by these generators are
/// automatically serializable.
///
/// Import the generators you want and pass them to [build] as shown,
/// specifying which files in which packages you want to run against.
Future main(List<String> args) async {
  var actions = apply('mimicry_generator',
      [(_) => new LibraryBuilder(new JsMimicryGenerator(), generatedExtension: '.js.g.dart')],
      toRoot(),
      defaultGenerateFor: const InputSet(include: const <String>[
        'lib/**.dart',
        'test/**.dart'
      ]),
      hideOutput: false
  );

  await build([actions], deleteFilesByDefault: true);
}
